<template>
	<aside class="theme-builder-drawer mdc-drawer">
		<div class="mdc-drawer__header">
			<h1 class="theme-builder-title mdc-typography--headline5">
				<svg width="24px" height="24px" viewbox="0 0 24 24" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">
					<defs>
						<path d="M23.8461538,12 C23.8461538,5.46307692 18.5369231,0.153846154 12,0.153846154 C5.46307692,0.153846154 0.153846154,5.46307692
              0.153846154,12 C0.153846154,18.5369231 5.46307692,23.8461538 12,23.8461538 C18.5369231,23.8461538 23.8461538,18.5369231 23.8461538,12
              Z M4.46153846,18.0738462 C3.11538462,16.4153846 2.30769231,14.3046154 2.30769231,12 C2.30769231,9.70615385 3.12615385,7.60615385
              4.46153846,5.93692308 L4.46153846,18.0738462 Z M18.0738462,4.46153846 L5.92615385,4.46153846 C7.58461538,3.11538462 9.69538462,2.30769231
              12,2.30769231 C14.3046154,2.30769231 16.4153846,3.11538462 18.0738462,4.46153846 Z M12,14.7246154 L7.95076923,6.61538462 L16.06,6.61538462
              L12,14.7246154 Z M17.3846154,8.76923077 L17.3846154,17.3846154 L13.0769231,17.3846154 L17.3846154,8.76923077 Z M10.9230769,17.3846154
              L6.61538462,17.3846154 L6.61538462,8.76923077 L10.9230769,17.3846154 Z M18.0738462,19.5384615 C16.4046154,20.8846154 14.2938462,21.6923077
              12,21.6923077 C9.70615385,21.6923077 7.58461538,20.8846154 5.92615385,19.5384615 L18.0738462,19.5384615 Z M21.6923077,12 C21.6923077,14.3046154
              20.8846154,16.4153846 19.5384615,18.0738462 L19.5384615,5.93692308 C20.8738462,7.60615385 21.6923077,9.70615385 21.6923077,12 Z" id="mdc-logo-path"></path>
					</defs>
					<g stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">
						<g transform="translate(-29.000000, -48.000000)">
							<g>
								<g transform="translate(0.000000, 44.000000)">
									<g transform="translate(29.000000, 0.000000)">
										<g transform="translate(0.000000, 4.000000)">
											<mask fill="white">
												<use xlink:href="#mdc-logo-path"></use>
											</mask>
											<use fill="#5F6367" fill-rule="nonzero" xlink:href="#mdc-logo-path"></use>
										</g>
									</g>
								</g>
							</g>
						</g>
					</g>
				</svg>
				LightBox Layout Demo
			</h1>
		</div>
		<hr class="mdc-list-divider theme-builder-drawer-divider">

		<div class="mdc-tab-bar" role="tablist">
			<div class="mdc-tab-scroller">
				<div class="mdc-tab-scroller__scroll-area">
					<div class="mdc-tab-scroller__scroll-content">
						<button class="mdc-tab mdc-tab--active drawer-tab--instructions" role="tab" aria-selected="true" tabindex="0">
                <span class="mdc-tab__content">
                  <span class="mdc-tab__text-label">Instructions</span>
                </span>
							<span class="mdc-tab-indicator mdc-tab-indicator--active">
                  <span class="mdc-tab-indicator__content mdc-tab-indicator__content--underline"></span>
                </span>
							<span class="mdc-tab__ripple"></span>
						</button>
						<button class="mdc-tab drawer-tab--theme-summary" role="tab" aria-selected="true" tabindex="0">
                  <span class="mdc-tab__content">
                    <span class="mdc-tab__text-label">Theme Summary</span>
                  </span>
							<span class="mdc-tab-indicator">
                    <span class="mdc-tab-indicator__content mdc-tab-indicator__content--underline"></span>
                  </span>
							<span class="mdc-tab__ripple"></span>
						</button>
					</div>
				</div>
			</div>
		</div>
		<hr class="mdc-list-divider theme-builder-drawer-divider">

		<div class="mdc-drawer__content drawer-content--instructions">
			<h6 class="mdc-typography--overline">How to build a theme</h6>
			<p class="mdc-typography--body2">
				Build your own custom Material theme by <a href="https://glitch.com/edit/#!/remix/material-theme-builder" target="_blank">remixing</a> and styling these themeable components.
			</p>
			<p class="mdc-typography--body2">
				Modify the variables in your project's <code>my-theme.scss</code>, <code>my-components.scss</code>, and <code>my-theme.js</code> files to see your custom styles applied across
				<a href="https://github.com/material-components/material-components-web">Material Components for the web</a>.
			</p>

<!--			<div class="drawer-content&#45;&#45;options">-->
<!--				<h6 class="mdc-typography&#45;&#45;overline">Options</h6>-->
<!--				<div class="mdc-form-field">-->
<!--					<div class="mdc-switch rtl-switch">-->
<!--						<div class="mdc-switch__track"></div>-->
<!--						<div class="mdc-switch__thumb-underlay">-->
<!--							<div class="mdc-switch__thumb">-->
<!--								<input type="checkbox" id="rtl-input" class="mdc-switch__native-control" role="switch">-->
<!--							</div>-->
<!--						</div>-->
<!--					</div>-->
<!--					<label for="rtl-input">Enable Right-to-Left</label>-->
<!--				</div>-->
<!--			</div>-->
		</div>

		<div class="mdc-drawer__content drawer-content--theme-summary">
			<div class="section-header">
				<a href="https://material.io/design/color/the-color-system.html#tools-for-picking-colors" class="mdc-typography--overline" target="_blank">
					<i class="material-icons leading-icon">colorize</i>
					Color Scheme
					<i class="material-icons">open_in_new</i>
				</a>
			</div>
			<div class="theme-summary-line">
				<code class="theme-summary-code theme-summary-code--primary">$mdc-theme-primary</code>
				<figure class="theme-summary-color theme-summary-color--primary"></figure>
			</div>
			<div class="theme-summary-line">
				<code class="theme-summary-code theme-summary-code--on-primary">$mdc-theme-on-primary</code>
				<figure class="theme-summary-color theme-summary-color--on-primary"></figure>
			</div>
			<div class="theme-summary-line">
				<code class="theme-summary-code theme-summary-code--secondary">$mdc-theme-secondary</code>
				<figure class="theme-summary-color theme-summary-color--secondary"></figure>
			</div>
			<div class="theme-summary-line">
				<code class="theme-summary-code theme-summary-code--on-secondary">$mdc-theme-on-secondary</code>
				<figure class="theme-summary-color theme-summary-color--on-secondary"></figure>
			</div>
			<div class="theme-summary-line">
				<code class="theme-summary-code theme-summary-code--error">$mdc-theme-error</code>
				<figure class="theme-summary-color theme-summary-color--error"></figure>
			</div>
			<div class="theme-summary-line">
				<code class="theme-summary-code theme-summary-code--on-error">$mdc-theme-on-error</code>
				<figure class="theme-summary-color theme-summary-color--on-error"></figure>
			</div>
			<div class="theme-summary-line">
				<code class="theme-summary-code theme-summary-code--surface">$mdc-theme-surface</code>
				<figure class="theme-summary-color theme-summary-color--surface"></figure>
			</div>
			<div class="theme-summary-line">
				<code class="theme-summary-code theme-summary-code--on-surface">$mdc-theme-on-surface</code>
				<figure class="theme-summary-color theme-summary-color--on-surface"></figure>
			</div>
			<div class="theme-summary-line">
				<code class="theme-summary-code theme-summary-code--background">$mdc-theme-background</code>
				<figure class="theme-summary-color theme-summary-color--background"></figure>
			</div>
			<hr class="mdc-list-divider theme-summary-divider">

			<div class="section-header">
				<a href="https://material.io/design/shape/about-shape.html#shape-customization-tool" class="mdc-typography--overline" target="_blank">
					<i class="material-icons leading-icon">border_style</i>
					Shape System
					<i class="material-icons">open_in_new</i>
				</a>
			</div>
			<div class="theme-summary-line theme-shape">
				<code class="theme-summary-code">$mdc-shape-small-component-radius:</code>
				<figure class="theme-summary-shape theme-summary-shape--small">S</figure>
			</div>
			<div class="theme-summary-line theme-shape">
				<code class="theme-summary-code">$mdc-shape-medium-component-radius:</code>
				<figure class="theme-summary-shape theme-summary-shape--medium">M</figure>
			</div>
			<div class="theme-summary-line theme-shape">
				<code class="theme-summary-code">$mdc-shape-large-component-radius:</code>
				<figure class="theme-summary-shape theme-summary-shape--large">L</figure>
			</div>
			<hr class="mdc-list-divider theme-summary-divider">

			<div class="section-header">
				<a href="https://material.io/design/typography/the-type-system.html" class="mdc-typography--overline" target="_blank">
					<i class="material-icons leading-icon">text_fields</i>
					Typography Scale
					<i class="material-icons">open_in_new</i>
				</a>
			</div>
			<div class="typography-callout">
				<code class="theme-summary-code">$mdc-typography--font-family:
					<span class="font-name varValue"></span>;</code>
				<a class="font-link mdc-typography--button" target="_blank">See on Google Fonts <i class="material-icons">open_in_new</i></a>
			</div>
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--headline1</code>
				<figure class="theme-summary-typography mdc-typography--headline1">H1</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--headline2</code>
				<figure class="theme-summary-typography mdc-typography--headline2">H2</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--headline3</code>
				<figure class="theme-summary-typography mdc-typography--headline3">H3</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--headline4</code>
				<figure class="theme-summary-typography mdc-typography--headline4">H4</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--headline5</code>
				<figure class="theme-summary-typography mdc-typography--headline5">H5</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--headline6</code>
				<figure class="theme-summary-typography mdc-typography--headline6">H6</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--subtitle1</code>
				<figure class="theme-summary-typography mdc-typography--subtitle1">Subtitle 1</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--subtitle2</code>
				<figure class="theme-summary-typography mdc-typography--subtitle2">Subtitle 2</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--body1</code>
				<figure class="theme-summary-typography mdc-typography--body1">Body 1</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--body2</code>
				<figure class="theme-summary-typography mdc-typography--body2">Body 2</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--button</code>
				<figure class="theme-summary-typography mdc-typography--button">Button</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--caption</code>
				<figure class="theme-summary-typography mdc-typography--caption">Caption</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
			<div class="theme-summary-line theme-summary-line--typography">
				<code class="theme-summary-code">$mdc-typography--overline</code>
				<figure class="theme-summary-typography mdc-typography--overline">Overline</figure>
			</div>
			<hr class="mdc-list-divider typography-baseline-divider">
		</div>
	</aside>
</template>
<script>
import {
	MDCTabBar,
} from '../m-components';

export default {
	name: 'side-bar',
	mounted() {
		this.updateUI();
	},
	methods: {
		updateUI() {

			// Tab

			//
			// Theme Builder drawer contents
			//

			const themeBuilderDrawerEl = document.querySelector('.theme-builder-drawer');

			// Theme Builder drawer tabs
			new MDCTabBar(themeBuilderDrawerEl.querySelector('.mdc-tab-bar'));
			const instructions = themeBuilderDrawerEl.querySelector('.drawer-content--instructions');
			const themeSummary = themeBuilderDrawerEl.querySelector('.drawer-content--theme-summary');
			themeBuilderDrawerEl.querySelector('.drawer-tab--instructions').addEventListener('MDCTab:interacted', () => {
				instructions.style.display = 'block';
				themeSummary.style.display = 'none';
			});
			themeBuilderDrawerEl.querySelector('.drawer-tab--theme-summary').addEventListener('MDCTab:interacted', () => {
				instructions.style.display = 'none';
				themeSummary.style.display = 'block';
			});

			// Build out color variable visualizer
			[...document.querySelectorAll('.theme-summary-color')].forEach((elem) => {
				// Get background value of color component and sanitize
				const bgColor = rgbToHex(getComputedStyle(elem).backgroundColor) || '';
				const node = document.createElement("span");
				const textNode = document.createTextNode(`: ${bgColor};`);
				node.classList.add('varValue');
				node.appendChild(textNode);

				// Append text of the element adjacent sibling to the end of the text string
				elem.previousElementSibling.appendChild(node);
			});
		}
	}
};

// Color Visualization
const rgbToHex = (col) => {
	if(col.charAt(0) === 'r') {
		col = col.replace('rgb(', '').replace(')', '').split(',');
		let r = parseInt(col[0], 10).toString(16);
		let g = parseInt(col[1], 10).toString(16);
		let b = parseInt(col[2], 10).toString(16);
		r = r.length === 1 ? '0' + r : r; g = g.length === 1 ? '0' + g : g; b = b.length === 1 ? '0' + b : b;
		let colHex = '#' + r + g + b;
		return colHex;
	}
};

</script>
